/* ESP32_button_bounce

   Nyomógomb pergésének vizsgálata megszakítással
   A GPIO5 bemenetre kötött nyomógomb lenyomásakor megszakításokat keltünk,
   s a megszakításokat egy gomblenyomás és -felengedés cilkus során számláljuk,
   majd az eredményt a soros porton kiíratjuk.

*/
#define button 5     // Külsö nyomógomb (GPIO 5)
#define led    2     // Beépített LED (GPIO 2)
volatile int counts; // Számláló

//--- Megszakítások kiszolgálása
void IRAM_ATTR button_pressed() {
  counts++;          // megszakítások számlálása
}


void setup() {
  Serial.begin(115200);
  pinMode(led, OUTPUT);
  digitalWrite(led, LOW);
  pinMode(button, INPUT_PULLUP);
  Serial.println("Press and release the builtin pushbutton!\r\n");
}

void loop() {
  counts = 0;                      // Számláló nullázása
  attachInterrupt(button, button_pressed, FALLING); //megszakítás hozzárendelés
  while (digitalRead(button));     // Lenyomásra várunk
  digitalWrite(led, HIGH);         // LED be
  delay(20);                       // pergésmentesítő várakozás
  while (!digitalRead(button));    // Felengedésre várunk
  digitalWrite(led, LOW);          // LED ki
  delay(20);                       // pergésmentesítő várakozás
  detachInterrupt(button);         // Hozzárendelés megszüntetése
  Serial.print("Button pressed "); // Az eredmény kiírása
  Serial.print(counts);
  Serial.println(" times\r\n");
}
