/* ESP32_button_interrupt.ino

   Nyomógombbal kiváltott megszakítás használata.
   A beépített BOOT nyomógomb (GPIO0) lenyomásakor megszakításokat keltünk,
   s a megszakítást kiszolgáló blink() függvényben a beépített LED
   (GPIO2) állapotát átbillentjük.

   A digitalPinToInterrupt(pin) függvény esetünkben csak azt ellenőrzi,
   hogy a megadott pin 40-nél kisebb, tehát nyugodtan elhagyható...

    IRAM_ATTR szepe az, hogy a bvisszahívási függvényt a RAM-ban tartsa,
    de ha nem időkritikus a kiszolgálás, akkor elhagyható...

*/
volatile byte led_state = LOW;   // Állapotváltozó

void setup() {
  pinMode(LED_BUILTIN, OUTPUT);  // LED_BUILTIN esetünkben GPIO2
  //Megszakítás a GPIO0 bemenetre kötött nyomógomb lenyomásakor
  attachInterrupt(digitalPinToInterrupt(0), blink, FALLING);
}

void loop() {

}

void IRAM_ATTR blink() {
  state = !state;                // change state at each interrupt
  digitalWrite(LED_BUILTIN, state);
}
